{ $Id: F_MIRC.PAS,v 3.16 2003/03/05 21:04:26 ralph Exp $ }

{ Find MIRC worms }

{*****************************************************************************}
{*                                                                           *}
{* USE:                                                                      *}
{* Hungarian Naming Conventionen (szStr, wWord, nInt, bBoolean...)           *}
{*                                                                           *}
{* (C)opyright by                                                            *}
{*           ----------------------------------                              *}
{*            ROSE Softwareentwicklung                                    *}
{*            Dipl.-Ing. Ralph Roth                                       *}
{*            Finkenweg 24                                                *}
{*                                                                        *}
{*            D 78658 Zimmern o. R.                                       *}
{*                                                                        *}
{*           ----------------------------------                             *}
{*             #################################                             *}
{*                                                                           *}
{*****************************************************************************}

{$I Comp.pas}
{$D+,L+}

Program F_Mirc;

{$IFDEF FPCMMX}
 {$IFNDEF VIRTUALPASCAL}  {$MMX+}  {$ENDIF}
 { not available in fpc 1.0.5 }
{$ENDIF}

uses
(* {$IFDEF FPC}{$IFNDEF VIRTUALPASCAL} mmx, {$ENDIF} {$ENDIF}  *)
      crt,
      dos,
{$IFnDEF FPC} netzwerk, syserr, {$ENDIF}
      r_utils, rstrings, rc4key,
      constant,
{$IFDEF LINUX} linux, {$ENDIF}
      avrvbs, avrwin32,
      kommando;

Const VirusMinLen = 40;         { Minimum length of a infecte file! }
      PATHLEN     = 45;         { Length of path printed on screen }
      RCS_ID_FMIRC : String =
'$Header: /home/CVS/tp/vir/F_MIRC.PAS,v 3.16 2003/03/05 21:04:26 ralph Exp $' ;
      {$i regnr.inc}

Var     { Stack! }
    szSearch    : String;
    szName      : String;
    szHome      : String;
    szParam     : String;
    szTmp       : String;
    lFound      : LongInt;
    lremoved    : LongInt;
    lChk        : LongInt;
    lSize       : Real;
    rTime       : Real;
    bDelete     : Boolean;
    bAllFiles   : Boolean;
    bLog        : Boolean;
    bLogAll     : Boolean; { rar,27020023 }
    oKZ         : PKommandoZeile;
    aKey        : Trc4key;
    hlogfile    : text;
(* ************************************************************************ *)

{

$Log: F_MIRC.PAS,v $
Revision 3.16  2003/03/05 21:04:26  ralph
MemScan 6.5.5 release (-nohma)

Revision 3.15  2003/02/27 18:47:17  ralph
F_Mirc 4.00beta:  -log, -logall, tons of fixes for log file handling

Revision 3.14  2003/02/02 20:29:42  ralph
Small enhancements and fixes done in Brechen.

Revision 3.13  2003/01/20 22:00:42  ralph
! fixes for Linux port/SuSE 8.1 pro

Revision 3.12  2003/01/05 21:57:42  ralph
Changed year y2k2 to y2k3

Revision 3.11  2002/12/08 21:38:55  ralph
! fixed all year 2001 references

Revision 3.10  2002/10/27 19:03:20  ralph
! small changes to compile with old fpc 1.0.5

Revision 3.9  2002/08/08 21:32:38  ralph
Added halt() handler to r_utils. Changed all halt; with halt(0);

Revision 3.8  2002/07/04 17:23:51  ralph roth
Small fixes for Runtime Error and Heap Leaks that FPC claims...

Revision 3.7  2002/06/26 21:52:42  ralph
Fixed some memory heap leaks using fpc -gh -gl functions

Revision 3.6  2002/06/18 19:18:53  ralph
Changes for RC4 KeyMaker

Revision 3.5  2002/05/05 16:22:54  ralph
Changes to get RFW 2.10 work, FPC 1.0.6 fixes.

Revision 3.4  2002/03/21 16:52:40  ralph
Added check for virscan.irc - mailed to Andreas Haak

Revision 3.3  2002/03/17 22:13:53  ralph
F_MIRC 2.31 send out to Andreas Haak for .DLL support

Revision 3.2  2002/01/09 19:46:14  ralph
Changed Copyright: Year 2001 -> 2002

Revision 1.13  2001/07/30 15:56:34  rar_ulm
2.21 - fixed changes introduced with AVR_MIRC()

Revision 1.12  2001/06/26 20:30:40  rar_ulm
Version 2.20 send out to Darwin Zamora

Revision 1.11  2001/04/21 12:47:02  rose_swe.p200
Version 2.13 - Released
+ up to 20% faster DOS16 version
+ JSE+VBE encryption on the fly, new viruses added
+ new scan enginees added

Revision 1.10  2001/04/07 13:46:03  rar_ulm
F_Mirc 2.11.3 - FindClose/FileStats for Linux added
Fixed an error with LFN unit

Revision 1.9  2001/03/24 22:23:59  rose300
2.12b - Linux enhancements

Revision 1.7  2001/03/11 12:16:51  rose300
F_Mirc 2.11, works fine under Linux + DOS/Win32. Merged Linux depended
stuff to R_UTILS.PAS

Revision 1.6  2001/03/08 21:21:15  rar
2nd Linux Beta version (F_Mirc 2.11) - new VBS engine meanwhile for VBS.SST

Revision 1.5  2001/01/24 20:05:28  rar
First working beta for Linux, fixed bug with more than 2^32 bytes
great drives.

Revision 1.4  2001/01/21 23:54:27  rar
2.10 beta 2 - works now under linux, execpt when scaning root (/)

Revision 1.3  2001/01/21 16:17:24  rose_p300
F_mirc 2.10 - before tested under Linux

Revision 1.2  2001/01/18 22:26:14  rar
Bloody Linux Alpha version (2.00b2)

}

{ ------------------------------------------------------------------- }
{$IFDEF LINUX}

Function IsRegularFile(szFile: String): Boolean;

Var
    stInfo : Stat;
    bTmp   : Boolean;

Begin

        IsRegularFile := FALSE;
        If Not FStat(szFile, stInfo)
                Then exit;

        bTmp := (Not S_ISLNK(stInfo.mode) And Not S_ISSOCK(stInfo.mode))
                 And (LinuxError = 0);

        If bTmp Then
           If S_ISCHR(stInfo.mode)
             { or S_ISBLK(stInfo.mode) }
              Or S_ISFIFO(stInfo.mode)
                Then
                        bTmp := FALSE;

        IsRegularFile := bTmp;
End;
{$ENDIF}

{ --- [Writeln1 ] ------------------------------------------------------- }

Procedure writeln1(szWhat: String);

Var t, v : Byte;

Begin
     For t := 1 To length(szWhat) Do
       Begin
          v := byte(szWhat[t]);
          textcolor(7);
          If v < 48 Then textcolor(3);
          If v In [91..96] Then textcolor(3+8);
          If v > 122 Then textcolor(1+8);
          If v = 254 Then textcolor(white);
          write(szWhat[t]);
        End;
     If blog Then
        writeln(hlogfile, szWhat);
     textcolor(7);
     writeln;

End; { writeln1 }

{ ------------------------------------------------------------------- }

Procedure Bearbeite(pfad: String);

Var sr: SearchRec;
        r1 : Byte;
        hIn : File;
        buffer : Array[0..$20] Of byte;
        lCrc32 : LongInt;

Begin { Bearbeite }

  If Length(Pfad) >= sizeof(PathStr) Then
    Begin
      clreol;
      writeln1('Error - Path to long: '+ Pfad);
      exit;
    End;

  FindFirst(pfad+SLASH+FILEMASKALL, AnyFile-VolumeId, sr);
  while (DosError=0) Do
    Begin
      If ((sr.attr And Directory) = Directory) And
         { LiNUX! }
         {$ifdef LINUX} (pfad+sr.name <> '/proc') And
         IsRegularFile(pfad+SLASH+sr.name) And   {$endif}
         (sr.name <> '.') And (sr.name <> '..') Then
        Begin
          szName := pfad + SLASH + sr.name;
          chdir(szName);
          If (ioresult = 0) And (DosError = 0)
             Then bearbeite(szName)
             Else If oKZ^.IsOption('cde')
                    Then writeln1('Error - Can not chdir to '+szName+'!');
        End;

      szName := pfad+ SLASH + sr.name;
      If ((sr.attr And Directory) <> Directory)
         {$ifdef LINUX} And IsRegularFile(szName) {$endif}
         Then  { sr.name <> '.' }
        Begin
          write(pathfit(szname, {PATHLEN} 77 ));
          clreol;
          write(#13);

          inc(lChk);
          lSize := lSize + sr.size;

          szSearch := '';
        { targets }
          If (IsHtmlExtension(sr.Name) Or IsExeExtension(Sr.Name) Or bAllFiles) And
             (sr.size > VIRUSMINLEN)
            Then
            Begin
              szSearch := AVR_Mirc(szName, FALSE);        { 28.07.2001, rar }
            { if szSearch <> '' then szSearch := szSearch + ' Worm'; }
              If szSearch = '' Then
                szSearch := AVR_VBS(szName, FALSE);
            { if szSearch <> '' then szSearch := szSearch + ' Script'; }
            End;

          If (szSearch='') AND (sr.size > 2048) AND
             FopenBin(hIn, szName) Then  { <2K? access denied? }
            Begin
                For r1 := 0 To $20 Do
                        buffer[r1] := 0;

              blockread(hIn, buffer, $20);      { head }

              { new, 27.05.2000 }
              lCrc32 := CheckSum(@buffer[0]);
              szSearch := Trojan_Win32(szName, FileSize(hIn), lCrc32 );
              close(hIn);
              If ioresult <> 0 Then   { pascal simly sucks here };
            End;

          If (szSearch <> '') And (szSearch[1] <> '[') Then
            Begin
              inc(lFound);
              textcolor(white);
              write(PadR(pathfit(szName, PATHLEN), PATHLEN+3));
              If blog
                  Then writeln(hlogfile, szName+#9+szSearch);       { full name here! }
              textcolor(lightred);
              writeln(szSearch);
              textcolor(7);

              If bDelete Then
                Begin
                  unlink(szName);
                  inc(lRemoved);
                  If blog Then
                    writeln(hlogfile,'Removed: '+szName);         { full name here! }
                End;
            End
                else if bLogAll then
                        writeln(hLogFile, szName+#9+'- OK? -');
        End;


      FindNext(sr);
      If keypressed Then exit;
    End;

  FindClose(sr);

  chdir('..');
  If ioresult <> 0 Then {-???- FATAL! };

End; { Bearbeite }

{ --- [Statistik] --------------------------------------------------------- }

Procedure Statistik;  { 08.01.97 }

Var s : String;
    lMB : LongInt;

 Function lFormat(l : LongInt) : String;

 Var s : String;

 Begin { format }
   s := Format(l);
   while length(s) < 10 Do s := ' '+s;
   lFormat := s;
 End; { format }

 Begin { Statistik }
   clreol;
   writeln;
   writeln1(GuruHeadLine('Statistics'));
   writeln;
   lMB := trunc(lSize / (1024.0 * 1024.0));
   writeln1('| Files checked ............................ '+lformat(lChk)+ '  '+format(lMB )+' MB');
   If lChk>0 Then str((lFound/lChk)*100.0: 3: 1,s)
                                              Else s := '0.0';
   writeln1('| Suspicious files ......................... '+lformat(lFound)+'         ('+s +'%)');

   If lFound > 0 Then str(lRemoved/lFound*100.0:3:1,s)
                Else s := '0.0';
   writeln1('| Files cleaned/killed ..................... '+lFormat(lRemoved)+'         (' +s+'%)');
   writeln1('| Scanning time needed ..................... '+lFormat(Trunc(rTime))+ '  Seconds (CPU)');
   writeln;
   writeln1(GuruHeadLine('Scanning finished! Have a virus free time!'));

 End; { Statistik }

{ ---------------------------------------------------------------------------- }

Procedure FileNotFound(szFile: String);

Begin { FileNotFound }
       writeln1(GuruHeadLine('Fatal Error'));
       writeln1('File: '+szFile+' not found or access denied!');
       dispose(oKZ, done);
       close(hlogfile);
       halt(8);
End; { FileNotFound }

{ ------[MAIN]--------------------------------------------------------- }

Begin

  bLog := FALSE; { needed by writeln1 }
  writeln;
  new(oKZ, init);
  bLogAll := oKZ^.IsOption('LogAll');
  bLog := oKZ^.IsOption('Log') or bLogAll;

  If blog Then
    Begin
      szTmp := oKZ^.GetString('LOG');
      If szTmp = '' Then szTmp := '.'+SLASH+'f_mirc.log';
      Assign(hLogfile,szTmp);
      append(hLogfile);
      If ioresult <> 0 Then
        Begin
                Rewrite(hLogfile);
        End;
          if ioresult <> 0 then FileNotFound(szTmp);    { abort! }
    End;

  writeln1(GuruHeadLine('F-mIRC'+
          {$IFDEF FPC}
           {$IFDEF LINUX}
            ' (Linux)'+
           {$ELSE}
            '/w32'+
           {$ENDIF}
          {$ENDIF}
           ' 4.01-'+klformat(BUILD_F_MIRC)+' - mIRC/pIRC & Script Worm Detector'));
  writeln1('(c) 1994-2003 by ROSE SWE, Ralph Roth, http://come.to/rose_swe');

  If (oKZ^.paramcounter < 1) Or (oKZ^.IsOption('?')) Or (oKZ^.IsOption('h'))
     Or (oKZ^.HasDrives = FALSE)
    Then
    Begin
      writeln1( 'Program Credits: A. Marx, A. Haak, A. Pettinger, J. Hartmann & Flo' );
      writeln;
      writeln1(GuruHeadLine('Usage and parameters'));
{$ifdef LINUX}
      writeln('usage: f_mirc [.|..|/path] [-del|-all|-cde] [-log[=mylog]] [-?|-h]');
{$else}
      writeln('usage: F_Mirc drive:[\path] [-del|-all|-cde] [-log[=mylog]] [-?|-h]');
{$endif}
      writeln;
      writeln('-? -h              Show this short help.');
{$IFDEF LINUX}
      writeln('/                  Scans recursivly from the root directory.');
      writeln('/dir/subdir        Scans recursivly from the given directory.');
{$ELSE}
      writeln('Drive:  Drive:\    Scans recursivly the drive from the root directory.');
      writeln('Drive:\Path        Scans recursivly the drive from the given directory.');
{$ENDIF}
      writeln('. (..)             Scans recursivly the current directory (parent).');
      writeln('-all               Scan all files (*.*), default: .INI, .EXE, .VBS, .HT? etc.' );
      writeln('-cde               Show change directory errors (directory access denied)') ;
      writeln('-del -remove       Deletes infected files. No query is made!' );
      writeln('-log(=logfile.log) Create also a log file, default = f_mirc.log' );
      writeln('-logall            Log all files, infected and clean ones, use with -log');
      writeln;
      writeln1(GuruHeadLine('Detects und deletes the following variants'));
{   writeln1(' - Acoragil, Jeepwarez, Simpsalapim, Jobbo, Panterax, Inca, Sleepe
    writeln1(' - DMSetup, BC-Kipo, TooLame, Unable, Shorty, Protector, Whacked famil
}
      writeln1(' - Generic mIRC, pIRC Dropper+Worms detection ('+klformat(
               ANZAHL_MIRC_WORMS)+' variants)');
      writeln1(' - VBS, HTML, WBT, JS and Corel script detection ('+klformat(
               ANZAHL_VBS_VIREN)+' variants)');
      writeln1(' - Dropper, Trojans, Backdoors, Malware etc. ('+klformat(ANZAHL_TROJANS)+ ' variants)');
      writeln1(GuruHeadLine('FREEWARE! ALL RIGHTS RESERVED! USE AT YOUR OWN RISK!'));
      halt(0); { rar, 090802 }
    End;

  writeln;
  lFound        := 0;
  lChk          := 0;
  lRemoved      := 0;
  lSize         := 1.0;

  { those SIG files are needed! }
  If Not existonpath('virscan.wsm', szParam) Then
        FileNotFound(szParam);
  writeln1('| Path to VBS/WSM signs = '+ szParam);
  If Not existonpath('virscan.irc', szParam) Then
        FileNotFound(szParam);
  writeln1('| Path to BAT/IRC signs = '+ szParam);
  writeln1('| Heuristic signs used  = '+klformat(ANZAHL_MIRC_WORMS+ANZAHL_VBS_VIREN));

  aKey.szFile := 'f_mirc.ini';
  CheckRC4Key(aKey);


  Writeln1('| Registered to: ' + aKey.szUserName);
  If blog Then
        writeln(hLogfile, '| F_mirc Scanning Log, started: '+Datum+', '+time);
 { freemem(aKey);  --  memory leak? }

  GetDir(0, szHome);
  szParam := oKZ^.FirstPath;

  If oKZ^.IsOption('debug') Then
        writeln('| FirstPath = ', szParam, ' Home = ', szHome);

  ChDir(szParam);
  If ioresult <> 0 Then
    Begin
       writeln1(GuruHeadLine('Fatal Error'));
       writeln1('| Can not chdir to '+szParam);
       dispose(oKZ, done);
       close(hlogfile);
       halt(7);
    End;

  GetDir(0, szParam);

{$IFDEF LINUX}
  If szParam = '' Then szParam := '/';
{$ENDIF}

  writeln1('| Commandline = '+oKZ^.Params^);
  writeln1('| Scanning "'+szParam+'" for worms and scripts viruses.');
  writeln;

{$IFNDEF LINUX}                         { needed for win32? }
  If length(szParam) = 3
     Then szParam := copy(szParam, 1, 2);
{$ENDIF}

  bDelete  := oKZ^.IsOption('Del') or oKZ^.IsOption('Remove');
  bAllFiles := oKZ^.IsOption('All');


  If oKZ^.IsOption('Stdout')
     Then crt2con;

  If bAllFiles Then szTmp := '(All files)'
               Else szTmp := '(IRC, HTML/VBS/Scripts & Executables)';

  writeln1(GuruHeadLine({$IFDEF LINUX}GetHostName+':'+ {$ENDIF}
                PathFit(szParam, 30)+' '+szTmp));
  Writeln('Settings: Scan all files: ', bAllFiles,'  Delete files: ',bDelete);
  writeln;
  clearkeys;
  rTime := Timer;
  Bearbeite(szParam);
  rTime := Timer - rTime;
  clearkeys;

  Statistik;
  ChDir(szHome);

  If oKZ^.IsOption('Log') Then
  begin
        writeln(hLogFile,#13#10'/End of Logfile/'#13#10);
        close(hLogfile);
  end;
  dispose(oKZ, done);
  close(output);
End.
