UNIT r_Utils;
{$S-,V-,R-,I-}

{$IFNDEF FPC}
{$O+,F+,G+}
{$ENDIF}

{
$Log: r_utils.pas $
Revision 1.5  2001/03/08 21:23:29  rar
Many enhancements for porting to win32 and linux added

Revision 1.4  2001/02/07 23:10:41  rar
PlayASong, GuruHeadLine fixes

Revision 1.3  2001/01/21 23:51:34  rar
GuruHeadLine ported to Linux

Revision 1.2  2001/01/18 22:05:44  rar
Compilable under Linux (changed Fexpand(ParamStr(0)), removed DECODE_STR

Revision 1.1  2001/01/13 18:57:17  rose_swe.p300
Initial revision
}

Interface

USES Dos,     { MS-DOS Zugriff }
     Crt ;    { Video, Farben }

{-- Typen und globale Variable ----------------------------------------}

CONST
     ProgDatum           : STRING[10] = '22.03.1990';
     Ver                 : STRING[16] = 'Ver 1.0';
     Name                : STRING[16] = 'ROSETOOL';
     BildsAdr            : Word = $B800;
     SoundVa             : BOOLEAN = TRUE;
     adapter_test        : BOOLEAN = TRUE;    { Hercules=TRUE }
     RCS_ID_RUTILS       : String [80] =
     '$Header: C:/TP/RCS/r_utils.pas 1.5 2001/03/08 21:23:29 rar Exp $';


     IoCtrlBlockBits : Array[0..15] of String[26] =
                  ('Bit0??','32 Bit','Bit2??','Bit3??','Bit4??','Bit5??',
                   'Generic IOCTL+GET/SET NO.','QUERY IOCTL','Bit8??',
                   'Shared','Bit10??','IOCTL Change','Network','Need FAT',
                   'IOCTL Read/Write','Substed');

{$IFDEF LINUX}
        SLASH = '/';
        FILEMASKALL = '*';
{$ELSE}
        SLASH = '\';
        FILEMASKALL = '*.*';
{$ENDIF}

TYPE FileName            = STRING[65] ;
     List                = ARRAY[0..700] OF STRING[70]; {fuer Dateinamen usw }
     Nibble              = 0..15;
     ROMentry            = ARRAY[1..8] OF Byte;
     ScreenSaver = RECORD
                      Attr : Byte;
                      Xc,Yc: Byte;
                      Wi,Wa: Word;
                      Bilds: ARRAY[0..4000] OF Byte;
                   END;
     NoteRecord     = RECORD
                        C,CF,D,DF,E,F,FF,G,GF,A,AF,B: INTEGER;
                      END;


VAR  szParam0            : String;
     OldExitProc         : Pointer;
{$IFNDEF FPC}
     Table               : ARRAY[0..255] OF ROMentry Absolute $F000:$FA6E;
     HardWareTimer       : LongInt Absolute $40:$6C;
{$ENDIF}

(* *********************** U T I L S ************************************** *)

            { Avaible Functions & Procedures: }

PROCEDURE Writexy        ( X,y : Byte ; Aus : STRING);
FUNCTION  FreeMem        : INTEGER ; { in KB }
FUNCTION  DiscFreeKB     : LongInt ; { vom aktuellen Laufwerk in KB }
FUNCTION  DiscSizeKB     : LongInt ; { vom aktuellen Laufwerk in KB }
FUNCTION  Exists         (FileName : STRING) : BOOLEAN;
FUNCTION  CurrentDisk    :STRING; { Gibt die aktuelle Disk zurck }
FUNCTION  CurrentDrive   :INTEGER; { Gibt die aktuelle Laufwerksnummer zurck }
FUNCTION  CurrentPath    :STRING; {gibt das aktuelle Unterverzeichnis zurueck}
FUNCTION  Frage          :CHAR;   { Fragt Ja oder Nein , Ergebnis J oder N   }
FUNCTION  Datum          :STRING;  (* Gibt das Datum als String aus *)
FUNCTION  Open           (VAR Fp:TEXT; Name: Filename): BOOLEAN;
FUNCTION  OpenMain       : STRING;                       (* ffnet Datei *)
PROCEDURE Linie          (zeichen,anz : Byte) ;
FUNCTION  Datnametest    (datname: STRING) : BOOLEAN;
FUNCTION  Upper          (s:STRING) : STRING;
FUNCTION  Finddir        (var subdir:STRING):BOOLEAN;   { Sucht Subdirectory}
FUNCTION  FormatReal(zahl : Real): STRING;
FUNCTION  FORMAT         (zahl : Longint): STRING;      { fuer LongInt }
FUNCTION  KLFORMAT       (zahl : INTEGER): STRING;      { fuer Integer }
PROCEDURE Quicksort      (VAR A: List; Lo,Hi: INTEGER);
FUNCTION  KillSpace      (s : STRING) : STRING;
FUNCTION  Wandle_Datum   ( Dat : LongInt ) : STRING ;
FUNCTION  Wandle_Time    ( Dat : LongInt ) : STRING ;
FUNCTION  Compress_Date  : LongInt;                  {Packt aktuelle Zeit}
FUNCTION  Date:          STRING;
FUNCTION  Time:          STRING;
PROCEDURE RAHMEN         (x,y,laenge,tiefe:INTEGER);
PROCEDURE Frame          (x,y,laenge,tiefe:Byte);
PROCEDURE FrameFarbe     (x, y, laenge, tiefe:Byte);
PROCEDURE Frame2         (x,y,laenge,tiefe:Byte);
FUNCTION  Zahl_zu_Wort   (zahl : Longint; Opt : CHAR ) : STRING;
FUNCTION  Copyright      : STRING;
FUNCTION  UpCase         (CHR : CHAR) : CHAR;
FUNCTION  LoCase         (CHR : CHAR) : CHAR;
FUNCTION  RoemZahl       ( X : Word ) : STRING;
                         { Wandelt eine Zahl ins Rmische um. 7 -> VII }
PROCEDURE ExecCommand    (com : STRING);
FUNCTION  Wandle_zeit    (time : REAL) : STRING;
PROCEDURE Printlogo      ( X,y : Byte);
PROCEDURE Del_Junk       ( VAR Work : STRING); { befreit string von nicht
                                                 ASCII-Zeichen }
function  Maximum        ( erste, zweite : LongInt) : LongInt;  { Gibt Maximum zurck }
function  Minimum        ( erste, zweite : LongInt) : LongInt;  { Gibt Minimum zurck }
function  PathFit        ( What: String;  MaxLen : Byte) : String;
                         { Krzt einen Patheintrag "What" auf MaxLen Zeichen ab. }
Function  GuruHeadLine   (szWork: String) : String; { -=[ Text ]=- }
function  IsVga          : boolean;        { haben wir VGA }
function  IsEGA          : boolean;        { liegt wenigstens EGA vor }
FUNCTION  TKey           : CHAR;

{ -------------------------- T P D O S ----------------------------- }

Function  FileSplit(datei : pathstr) : Namestr; {-liefert nur den 12 Zeichen langen Namen zurck}
Function  FOpenBin(var hIn: File; szName: String) : Boolean;
Function  ExtSplit(datei : pathstr) : Extstr;
Function  FileNameSplit(datei : pathstr) : String;
Function  Existonpath(such : string; var pfad : string): Boolean;
Function  DirSplit(Source : pathstr) : pathstr;
Function  DirAdust(Source : pathstr) : pathstr;
Function  GetCompanionFileName(Source : pathstr) : pathstr;
{$IFnDEF FPC}
Function  IOCTLDevLocal(Drive : Byte) : Word;
Function  NumberOfDrives : Byte;
{$ENDIF}
Procedure UnLink(szFile: String);

{ -------------------------- D O S V 2 ----------------------------- }

procedure Crt2Con;                 { leitet Write(ln) auf CON um }
PROCEDURE ClearKeys;
FUNCTION  Attribute      (a : Byte) : STRING;
FUNCTION  bit(w : word; anz : nibble): BOOLEAN;
PROCEDURE setbit(VAR w : word; anz : Nibble);
PROCEDURE resbit(VAR w : word; anz : Nibble);
PROCEDURE InstallExitProc;       {Installiert einen Errorhandler}
FUNCTION  Hexpointer(x: Pointer) : STRING;
FUNCTION  HexLong(x: Longint) : STRING;
FUNCTION  ErrorMessage(code:INTEGER):STRING;
FUNCTION  Hex(number:LongInt; digit: Byte):STRING;  { Dez. in Hex. }
FUNCTION  DezToHex(x : longint) : STRING;   { Hexzahl ohne fhrende Nullen. }
procedure ext_mkdir(szDir : String);    { legt Verzeichnisse rekursiv an }
PROCEDURE ErrBeep;
PROCEDURE BildHolen(VAR scr :ScreenSaver);
PROCEDURE BildSpeichern(VAR scr :ScreenSaver);
PROCEDURE Play(Octave,Note,Duration: INTEGER);
PROCEDURE PlayASong;
PROCEDURE SoftAlarm;
PROCEDURE Sirene;
PROCEDURE Siren;
FUNCTION Timer : REAL;
{$IFNDEF FPC}
PROCEDURE MakeTitle(title : String; Starting_row, w : Byte);
PROCEDURE UmRahme(a : STRING; Zeile : Byte);
PROCEDURE RAND(x,y,laenge,tiefe:INTEGER);
PROCEDURE Fwritexy(x,y : Byte ; A : STRING);
PROCEDURE fwriteln(st : STRING);
PROCEDURE CENTER(zeile:INTEGER;a:STRING);
PROCEDURE schatten (x,y : Byte);
PROCEDURE FUELLE(x0, y0, x, y1 : Byte);
procedure fuelle_schatten(x1,y1,x2,y2 : Byte);
PROCEDURE CursorAus;
FUNCTION  DriveExists(drive: CHAR) : BOOLEAN; { Prft ob Laufwerk existiert}
{$ENDIF}
PROCEDURE NotEnoughMemory(ST: STRING); { Memory Error-Routine}
Procedure CheckValidDosVersion;

{ ---------------------- H I G H S C O R E S ------------------------ }

FUNCTION    DECODE_A_STRING   (DUMMY : STRING; CODE : BYTE) : STRING;
FUNCTION    ENTCODE_A_STRING  (DUMMY : STRING; CODE : BYTE) : STRING;


(* ********************************************************************** *)

Implementation


